#ifndef _COBPP_H
#define _COBPP_H

#include <stdlib.h>
#include <stdio.h>

#define PATHMAX 		120
#define PATHMAX1 		1024
#define PATHMAX2 		256
#define CHR_SQUOTE		'\''
#define CHR_DQUOTE		'"'
#define CHR_SLASH		'/'
#define CHR_EOS			'\0'
#define CHR_ASTERIX		'*'
#define CHR_COLEN		':'
#define STR_DASH		'-'
#define STR_UNDERSCORE		'_'
#define STR_COLEN		":"
#define STR_SEARCH_SUFFIXES	".cpy:.CPY:.cob:.COB:.cbl:.CBL::"

#define STATE_FLIT_LNONE	1
#define STATE_FNAME_LNONE	2
#define STATE_FLIT_LLIT		3
#define STATE_FLIT_LNAME	4
#define STATE_FNAME_LLIT	5	
#define STATE_FNAME_LNAME	6

extern char HTG_COPYDIR[];

typedef short bool;

struct s_Env {
   bool codeFormat; /* 1 is free , 0 is fixed */
   int  debugFlag;
   int  errFlag;
   int  verboseFlag;
   int  tab2space;
   char *progName;
   char *ifname;
   char *ofname;
   char *lfname;
};

typedef struct s_Env Env;

Env globalEnv;
Env *globalEnvPtr;

static struct cpyinfo {
	char *cpybook;
	char *cpylib;
}copyinfo[10];

static int fsp=0;

/* Usage list */
/* Usage: %s <options> <input_file> [-o <output_file>]\n" */
static char usage_list0[] = { "<options> <input_file> [-o <output_file>]\n" };
static char usage_list1[] = { "where <options> are:\n\
      -h                Help (display this listing)\n\
      -V	        Display version and exit\n\
      -v	        Verbode mode\n\
      -d	        Turn on debuging mode\n\
      -t <num>          Expand tabs to <num> space(s)\n\
      -o <output_file>  Output file name (default: standard output)\n\
      -p <listing_file> Listing file name \n\
      -x <input_file>   Input source is in X/Open free format\n\
      -f <input_file>   Input source is in standard fixed column format\n\
      -I <copy_dir>     Copybooks search directories \n\
" };

/* command line options */
static char option_list[] = { "f:x:o:p:t:I:vV?hd" };

#define COBPP_NAME	"TinyCOBOL pre-processor"
#define COBPP_COPYWR	"Copyright (C) 1999-2000  David Essex"

/* htcobol.c */
void yyerror(char *s);
int  yyparse(void);

/* scan.c */
int yylex(void);
int yywrap(void);
void yyrestart(FILE *input_file);
int lex_fgets(char *buf, int maxsize);

extern char include_full_filename[];
int find_copybook_file(char *fname, char *lname);
int find_copybook_file2 (char *fname, char *lname);
int find_filename_text (char *fname, char *fp, char *fs);
int find_filename_literal (char *fname, char *fp);
char *find_env_variable (char *ev);
char *find_token(char *p, const char *d, int sw);

int setOptions(Env*, int, char**);
void setDefaults(void);
void printVersion(void);
void printHelp(void);
void CleanUp(void);

#endif
